# GBDK Playground

It has 16 kB of RAM, man.

## Samples
| [Blank](blank)            | [Hello World](hello_world)      | [Small Sprite](small_sprite)     |
|:-------------------------:|:-------------------------------:|:--------------------------------:|
| ![](blank/screenshot.png) | ![](hello_world/screenshot.png) | ![](small_sprite/screenshot.png) |
| Minimum required code     | Print `Hello World!`            | Render small 8x8 sprite          |

| [Big Sprite](big_sprite)       | [Big Sprite Animation](big_sprite_animation) | [Input State](input_state)      |
|:------------------------------:|:--------------------------------------------:|:-------------------------------:|
| ![](big_sprite/screenshot.png) | ![](big_sprite_animation/screenshot.gif)     | ![](input_state/screenshot.png) |
| Render big 16x16 sprite        | Animate big 16x16 sprite                     | Read joypad state               |

| [Input Wait](input_wait)       | [Move Sprite](move_sprite)      | [Background](background)        |
|:------------------------------:|:-------------------------------:|:-------------------------------:|
| ![](input_wait/screenshot.png) | ![](move_sprite/screenshot.gif) | ![](background/screenshot.png)  |
| Wait for button input          | Move a sprite using joypad      | Render a full-screen background |

| [Window](window)           | [Beep](beep)             | [Simple SHMUP](simple_shmup)     | 
|:--------------------------:|:------------------------:|:--------------------------------:|
| ![](window/screenshot.png) | ![](beep/screenshot.png) | ![](simple_shmup/screenshot.png) | 
| Renders a window           | Make a sound             | Very simple SHMUP                | 

| [Huge Sprite](huge_sprite)      | [Drawing](drawing)              | [Detect GB Type](detect_gb)        |
|:-------------------------------:|:-------------------------------:|:----------------------------------:|
| ![](huge_sprite/screenshot.png) | ![](drawing/screenshot.png)     | ![](detect_gb/screenshot.png)      |
| Renders a huge 40x64 sprite     | Built-in drawing functions      | Detect which GB is being used      |

| [Save RAM](save_ram)            | [Font](font)                    | [Link](link)                       |
|:-------------------------------:|:-------------------------------:|:----------------------------------:|
| ![](save_ram/screenshot.png)    | ![](font/screenshot.png)        | ![](link/screenshot.png)           |
| Save/load variables             | Load a new font                 | Send/Receive data using link cable |

| [Color](color)                  | More coming soon...                |
|:-------------------------------:|:----------------------------------:|
| ![](color/screenshot.png)       | ![](docs/res/more_coming_soon.png) |
| Use palettes for Game Boy Color | Contributions are welcome!         |
